-- Power bar module

local maxpower = 0
local currentpower = 0
local powertype
local powcolor = {}

function SN:SetupPower()

	local f = SN.F
	local v = SN.V
	f.powercontainer = CreateFrame("Frame", nil, UIParent)
	f.powercontainer:SetPoint("CENTER", UIParent, "CENTER", 0, 100)
	f.powercontainer:SetSize(258, 33)
	f.powercontainer:SetBackdrop({
				bgFile = v.media.blankTex,
				edgeFile = v.media.blankTex,
				tile = true,
				tileSize = 4,
				edgeSize = 4, 
				insets = { left = 4, right = 4, top = 4, bottom = 4 }
			})
	f.powercontainer:SetBackdropColor(0.1, 0.1, 0.1, 0.4)
	f.powercontainer:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	f.powercontainer:SetMovable(true)
	f.powercontainer:EnableMouse(true)
	f.powercontainer:SetScript("OnMouseDown", function(self, button)
		if button == "LeftButton" and not self.isMoving then
			self:StartMoving()
			self.isMoving = true
		end
	end)
	f.powercontainer:SetScript("OnMouseUp", function(self, button)
		if button == "LeftButton" and self.isMoving then
			self:StopMovingOrSizing()
			self.isMoving = false
		end
	end)
	--The actual power bar
	f.power = CreateFrame("StatusBar", nil, f.powercontainer)
	f.power:SetPoint("CENTER", f.powercontainer, "CENTER", 0, 0)
	f.power:SetSize(250, 25)
	f.power:SetStatusBarTexture(v.media.minTex)	
	f.power:SetStatusBarColor(powcolor.r, powcolor.g, powcolor.b, 1)
	f.power:SetMinMaxValues(0, (UnitPowerMax("player") > 0) and UnitPowerMax("player") or 100)	
	f.power:SetValue(UnitPower("player"))
	f.power:SetScript("OnUpdate", UpdatePower)
	f.power:SetBackdrop({
				bgFile = v.media.blankTex,
			})
	f.power:SetBackdropColor(0.1, 0.1, 0.1, 0)
	--The power text
	f.power.value = f.power:CreateFontString(nil, "OVERLAY")
	f.power.value:SetPoint("CENTER", f.power, "CENTER", 4, 0)
	f.power.value:SetFont(v.media.font, 14, "OUTLINE")
	f.power.value:SetJustifyH("CENTER")
	f.power.value:SetShadowOffset(1, -1)
	f.power.value:SetTextColor(0, 1, 0)
	f.power.value:SetText(currentpower.." / "..maxpower)

end

function SN:GetPowerColor()
	
	powertype = select(2, UnitPowerType("player"))
	print(powertype)
	if powertype == "MANA" then
		powcolor = SN.V.power.MANA
	elseif powertype == "RAGE" then
		powcolor = SN.V.power.RAGE
	elseif powertype == "FOCUS" then
		powcolor = SN.V.power.FOCUS
	elseif powertype == "ENERGY" then
		powcolor = SN.V.power.ENERGY
	elseif powertype == "RUNIC_POWER" then
		powcolor = SN.V.power.RUNIC_POWER
	end
	print(powcolor.r, powcolor.g, powcolor.b)
	return powcolor
	
end
function UpdatePower(frame)
	frame:SetValue(UnitPower("player"))
	currentpower = UnitPower("player")
	maxpower = UnitPower("player")
	frame:SetStatusBarColor(powcolor.r, powcolor.g, powcolor.b, 1)
	frame.value:SetText(currentpower.." / "..maxpower)
end

function SN:UpdatePowerType()
	 print("I just happened")
	SN:GetPowerColor()
	SN.F.power:SetValue(UnitPower("player"))
	currentpower = UnitPower("player")
	maxpower = UnitPower("player")
	SN.F.power:SetStatusBarColor(powcolor.r, powcolor.g, powcolor.b, 1)
	SN.F.power.value:SetText(currentpower.." / "..maxpower)
end